from batou.component import Component
from bp import BPServiceCheck

class RemoteCheck(Component):

    namevar = 'description'

    satellites = {'fr': 'France',
                  'gr': 'Greece',
                  'lv': 'Latvia',
                  'no': 'Norway',
                  'usa': 'USA'}

    def configure(self):

        for sat_mask, sat_desc in self.satellites.items():
            description = "{} from {}".format(self.description,
                                               sat_desc)
            self += BPServiceCheck(
                description,
                command='check_webpage_satellite',
                args='{}!{}!{}'.format(sat_mask, self.fqdn, self.uri),
                tags=map(lambda x: x+':remote', self.tags))


class DirectCheck(Component):

    namevar = 'description'

    def configure(self):
        self += BPServiceCheck(
            self.description,
            command='check_webpage',
            args="http://{}{} {}".format(self.fqdn, self.uri, self.args),
            tags=map(lambda x: x+':direct', self.tags))


class SatelliteCheck(Component):
    namevar = 'description'

    fqdn = ''
    uri = '/'
    notes_url = ''
    create_direct_check = True


    def configure(self):

        self += RemoteCheck(self.description,
                            fqdn=self.fqdn,
                            uri=self.uri,
                            tags=self.tags)

        if self.create_direct_check:
            self += DirectCheck(self.description,
                                fqdn=self.fqdn,
                                uri=self.uri,
                                args=self.args,
                                tags=self.tags)
